#      EditNumberWin.py - part of PyGCID
#      Copyright (C) 2000 Erik Forsberg
#      forsberg@lysator.liu.se

#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.

#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.

#      You should have received a copy of the GNU General Public License
#      along with this program, see the file COPYING; if not, write
#      to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
#      MA 02139, USA.



from gtk import *
from common import *
from Window import Window


class EditNumberWin(Window):
    def OKButtonPressed(self, widget):
        data = self.db.findNumber(self.number.get_text())
        if (None == data):
            data = {'lastTime':'Never'}
        if("" != self.origNumber and
           self.origNumber != self.number.get_text()):
            self.db.deleteNumber(self.origNumber)
        self.db.addNumber(self.number.get_text(),
                          comment = self.comment.get_text(),
                          lastTime = data['lastTime'],
                          note = self.note.get_chars(0,
                                                     self.note.get_length()), 
                          command = self.command.get_text())
        self.window.destroy()
        if(None != self.newCB):
            self.newCB()

    def cancelButtonPressed(self, widget):
        self.window.destroy()

    def __init__(self, number, db, newCB = None):
        self.origNumber = number
        self.db = db
        self.newCB = newCB
        Window.__init__(self, "PyGCID: Edit number")
        self.window.connect("destroy", self.window.destroy)
        vbox = GtkVBox(FALSE, 5)
        vbox.show()

        editLabel = GtkLabel("Number")
        editLabel.show()
        vbox.pack_start(editLabel)

        self.number = GtkEntry()
        self.number.set_text(number)
        self.number.show()
        vbox.pack_start(self.number)

        data = db.findNumber(number)
        if(None == data):
            data = {'lastTime':'Never', 'comment':'', 'note':'',
                    'command': ''}
        dateLabel = GtkLabel("Last call from number: %s" % data['lastTime'])
        dateLabel.show()
        vbox.pack_start(dateLabel)

        commentInfoLabel = GtkLabel("Comment: (Shown in incoming calls list)")
        commentInfoLabel.show()
        vbox.pack_start(commentInfoLabel)

        self.comment = GtkEntry()
        self.comment.set_text(data['comment'])
        self.comment.show()
        vbox.pack_start(self.comment)

        commandInfoLabel = GtkLabel("Command to run at incoming call from this number\n(%s in the command will be substituted by the number)")
        commandInfoLabel.show()
        vbox.pack_start(commandInfoLabel)

        self.command = GtkEntry()
        self.command.set_text(data['command'])
        self.command.show()
        vbox.pack_start(self.command)

        noteInfoLabel = GtkLabel("Note: (Shown in numbers list)")
        noteInfoLabel.show()
        vbox.pack_start(noteInfoLabel)

        self.note = GtkText()
        self.note.set_point(0)
        self.note.insert_text(data['note'])
        self.note.set_editable(TRUE)
        self.note.show()
        vbox.pack_start(self.note)

        buttonBox = GtkHBox()
        buttonBox.show()

        OKButton = GtkButton(label="OK")
        OKButton.show()
        OKButton.connect("clicked", self.OKButtonPressed)
        buttonBox.pack_start(OKButton)

        cancelButton = GtkButton(label="Cancel")
        cancelButton.show()
        cancelButton.connect("clicked", self.cancelButtonPressed)
        buttonBox.pack_start(cancelButton)

        vbox.pack_start(buttonBox)
                             
        self.window.add(vbox)
        self.window.show()
