#      FileDataBase.py - part of PyGCID
#      Copyright (C) 2000 Erik Forsberg
#      forsberg@lysator.liu.se
#      $Id: FileDataBase.py,v 1.2 2000/09/22 18:42:32 erik Exp $

#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.

#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.

#      You should have received a copy of the GNU General Public License
#      along with this program, see the file COPYING; if not, write
#      to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
#      MA 02139, USA.

from DataBase import DataBase
import time
import shelve
import os.path
from common import *

class FileDataBase(DataBase):
    def __init__(self, cfgPath):
        dbPath = os.path.join(cfgPath, "numberDb")
        debug("FileDataBase:__init__, opening %s" % dbPath)
        self.db = shelve.open(dbPath)
        if(None == self.db):
            raise "Couldn't open database!"

    def deInit(self):
        debug("FileDataBase:deInit")
        self.db.close()

    def addNumber(self, number, comment = '',
                  lastTime = time.asctime(time.localtime(time.time())),
                  note = '', command = ''):
        data = {}
        data['comment'] = comment
        data['lastTime'] = lastTime
        data['note'] = note
        data['command'] = command
        debug("Adding number %s to database" % number)
        self.db[number] = data

    def deleteNumber(self, number):
        del self.db[number]

    def findNumber(self, number):
        if("" == number):
            return None
        try:
            data = self.db[number]
        except KeyError:
            data = None
        return data

    def updateTime(self, number, data, lastTime):
        data['lastTime'] = lastTime
        self.db[number] = data

    def updateTime(self, number, data):
        data['lastTime'] = time.asctime(time.localtime(time.time()))
        self.db[number] = data

    def listNumbers(self):
        return self.db.keys()
#        ret = []
#        for key in self.db.keys():
#            ret = ret + [self.db[key]]
#        return ret
