#      NumberWin.py - part of PyGCID
#      Copyright (C) 2000 Erik Forsberg
#      forsberg@lysator.liu.se

#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.

#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.

#      You should have received a copy of the GNU General Public License
#      along with this program, see the file COPYING; if not, write
#      to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
#      MA 02139, USA.

from gtk import *
from common import *
from EditNumberWin import EditNumberWin
from Window import Window

class NumberWin(Window):
    def getNumber(self, row):
        return self.clist.get_text(row, 1)
    
    def addNumber(self, number):
        debug("NumberWin:addNumber(%s)" % number)
        data = self.parent.db.findNumber(number)
        if(None != data['comment']):
            comment = data['comment']
        else:
            comment = ""
        self.clist.freeze()
        self.clist.append([data['lastTime'], number, comment])
        self.clist.set_column_width(0, self.clist.optimal_column_width(0))
        self.clist.set_column_width(1, self.clist.optimal_column_width(1))
        self.clist.set_column_width(2, self.clist.optimal_column_width(2))
        self.clist.thaw()

    def SelectRow(self, clist, row, column, event):
        self.rowSelected = 1
        self.selectedRow = row

    def unSelectRow(self, clist, row, column, event):
        self.rowSelected = 0

    def editButton_clicked(self, button):
        if(self.rowSelected):
            EditNumberWin(self.getNumber(self.selectedRow),
                          self.parent.db)

    def destroy(self, win):
        self.window.destroy()
        self.parent.numberWin = None
        
    def __init__(self, initialNumber, parent):
        self.parent = parent
        Window.__init__(self, "PyGCID: Incoming calls")
        debug("NumberWin:__init__")
        self.window.connect("destroy", self.destroy)
        self.vbox = GtkVBox(FALSE, 5)
        self.vbox.show()
        self.clist = GtkCList(3, ["Time", "Number", "Comment"])
        self.clist.connect("select_row", self.SelectRow)
        self.clist.connect("unselect_row", self.unSelectRow)
        self.clist.set_sort_column(0)
        self.clist.set_sort_type(SORT_DESCENDING)
        self.clist.set_auto_sort(TRUE)
        self.clist.show()
        self.vbox.pack_start(self.clist)

        self.buttonBox = GtkHBox(FALSE, 5)
        self.buttonBox.show()

        closeButton = GtkButton("Close")
        closeButton.show()
        closeButton.connect("clicked", self.destroy)
        self.buttonBox.pack_start(closeButton)

        editButton = GtkButton("Edit number")
        editButton.show()
        editButton.connect("clicked", self.editButton_clicked)
        self.buttonBox.pack_start(editButton)

        self.vbox.pack_start(self.buttonBox)
        self.window.add(self.vbox)
        self.addNumber(initialNumber)
        self.window.show()
